﻿using System;
using System.Collections.Generic;
using System.Text;

using Xunit;

namespace Study.DelegateSeries.Test.UseFixture
{
    [Collection("DemoCollection")]
    public class UseFullFixtureDemo:IDisposable,IClassFixture<ClassFixtureDemo>
    {
        GlobalFixtureDemo globalDemo;
        ClassFixtureDemo classDemo;

        public UseFullFixtureDemo(GlobalFixtureDemo globalFixture, ClassFixtureDemo classFixture)
        {
            this.globalDemo = globalFixture;
            this.classDemo = classFixture;
        }

        [Fact]
        public void UseXUnitTest()
        {
            Assert.True(true,"已使用xUnit单元测试框架");
        }

        [Fact]
        public void GlobalFixtureTest()
        {
            Assert.NotNull(this.globalDemo);

            string selfName = globalDemo.GetType().Name;
            Assert.Equal(selfName, globalDemo.ShowSelf());
        }

        [Fact]
        public void ClassFixtureTest()
        {
            Assert.NotNull(this.classDemo);

            string selfName =classDemo.GetType().Name;
            Assert.Equal(selfName, classDemo.ShowSelf());
        }

        /// <summary>
        /// 清理：每测试
        /// </summary>
        void IDisposable.Dispose()
        {
            
        }
    }
}
